"""
搜索API
"""
from flask import Blueprint
from flask import request

import api
from facebook import FackBookBrowser

search_opt = Blueprint('search', __name__)



@search_opt.route('/user', methods=["POST"])
def search_user():
    """
    搜索抖音用户信息
    :return:
    """
    request_body = request.json
    user_url = request_body.get('url')
    api.assert_not_none(user_url, '用户链接不能为空')
    browser = FackBookBrowser(api.get_idle_account())
    result = browser.search_user(user_url)
    return api.success(result)


@search_opt.route('/batch-users', methods=["POST"])
def batch_users():
    """
    批量搜索抖音用户信息
    :return:
    """
    request_body = request.json
    user_urls = request_body.get('urls')
    api.assert_not_none(user_urls, '用户链接不能为空')
    browser = FackBookBrowser(api.get_idle_account())
    result = browser.batch_users(user_urls)
    return api.success(result)


@search_opt.route('/post', methods=["POST"])
def search_post():
    """
    搜索博文
    :return:
    """
    request_body = request.json
    post_url = request_body.get('url')
    api.assert_not_none(post_url, '博文链接不能为空')
    browser = FackBookBrowser(api.get_idle_account())
    result = browser.invoke(browser.search_post, url=post_url)
    return api.success(result)


@search_opt.route('/batch-notes', methods=["POST"])
def batch_notes():
    """
    根据关键字搜索抖音笔记、视频
    :return:
    """
    request_body = request.json
    note_urls = request_body.get('urls')
    api.assert_not_none(note_urls, '作品链接不能为空')
    browser = FackBookBrowser(api.get_idle_account())
    result = browser.batch_notes(note_urls)
    return api.success(result)

